{
  stdenv,
  fetchFromGitLab,
  libxslt,
  bash, # shebangs in share/ModemManager/fcc-unlock.available.d/,
  bash-completion,
  dbus,
  gettext,
  glib,
  libgudev,
  libqmi,
  meson,
  ninja,
  cmake,
  pkg-config,
  python3,
  systemd,
  gobject-introspection,
  pkgsBuildBuild,
  buildPackages
}: stdenv.mkDerivation rec {
  pname = "modemmanager";
  version = "1.22.0";

  src = fetchFromGitLab {
    domain = "gitlab.freedesktop.org";
    owner = "mobile-broadband";
    repo = "ModemManager";
    rev = version;
    hash = "sha256-/D9b2rCCUhpDCUfSNAWR65+3EyUywzFdH1R17eSKRDo=";
  };
  patches = [
    /home/dan/src/nixpkgs/pkgs/tools/networking/modemmanager/no-dummy-dirs-in-sysconfdir.patch
  ];
  nativeBuildInputs = [
    meson
    ninja
    gobject-introspection
    gettext
    pkg-config
    libxslt
    python3
    cmake
    glib # for gdbus-codegen
  ];

  buildInputs = [
    glib
    libgudev
    # polkit
     pkg-config
    # ppp
    # libmbim
    libqmi
    systemd
    bash-completion
    dbus
#    cmake
    bash # shebangs in share/ModemManager/fcc-unlock.available.d/
  ];

  depsBuildBuild = [
    pkg-config
  ];

  mesonFlags = [
    "-Dudevdir=${placeholder "out"}/lib/udev"
    "-Ddbus_policy_dir=${placeholder "out"}/share/dbus-1/system.d"
    "--sysconfdir=/etc"
    "--localstatedir=/var"
    "-Dvapi=false"
    "-Dmbim=false"
    "-Dqmi=true"
    "-Dqrtr=false"
    "-Dpolkit=no"
    "-Dplugin_foxconn=disabled"
    "-Dplugin_quectel=disabled"
    "-Dman=false"
    "-Dexamples=false"
    "-Dtests=false"
#    "-Dintrospection=false"
  ];

}
